wxWidgets: wxTCPConnection Class Reference

| Version: 3.1.5

Public Member Functions | List of all members
wxTCPConnection Class Reference
Class List by Category » Networking

`#include </home/Hamis/wxwidgets-3.1/wxWidgets3.1-3.1.5-1.i686/src/wxWidgets-3.1.5/interface/wx/sckipc.h>`

Inheritance diagram for wxTCPConnection:
[legend]

## Detailed Description

A wxTCPClient object represents the connection between a client and a server.

It emulates a DDE-style protocol, but uses TCP/IP which is available on most platforms.

A DDE-based implementation for Windows is available using wxDDEConnection.

A wxTCPConnection object can be created by making a connection using a wxTCPClient object, or by the acceptance of a connection by a wxTCPServer object. The bulk of a conversation is controlled by calling members in a wxTCPConnection object or by overriding its members.

An application should normally derive a new connection class from wxTCPConnection, in order to override the communication event handlers to do something interesting.

##

Library: wxNet

<>< =''>:</>&;&;< =''>\ </></>

See also
  wxTCPClient, wxTCPServer, Interprocess Communication

## Public Member Functions
| wxTCPConnection ()
| Constructs a connection object. More...
| wxTCPConnection (void *buffer, size_t size)
bool | Advise (const wxString &item, const void *data, size_t size, wxIPCFormat format=wxIPC_PRIVATE)
| Called by the server application to advise the client of a change in the data associated with the given item. More...
bool | Advise (const wxString &item, const char *data)
bool | Advise (const wxString &item, const wchar_t *data)
bool | Advise (const wxString &item, const wxString data)
virtual bool | Disconnect ()
| Called by the client or server application to disconnect from the other program; it causes the OnDisconnect() message to be sent to the corresponding connection object in the other program. More...
bool | Execute (const void *data, size_t size, wxIPCFormat format=wxIPC_PRIVATE)
| Called by the client application to execute a command on the server. More...
bool | Execute (const char *data)
bool | Execute (const wchar_t *data)
bool | Execute (const wxString data)
virtual bool | OnAdvise (const wxString &topic, const wxString &item, const void *data, size_t size, wxIPCFormat format)
| Message sent to the client application when the server notifies it of a change in the data associated with the given item. More...
virtual bool | OnDisconnect ()
| Message sent to the client or server application when the other application notifies it to delete the connection. More...
virtual bool | OnExecute (const wxString &topic, const void *data, size_t size, wxIPCFormat format)
| Message sent to the server application when the client notifies it to execute the given data. More...
virtual bool | OnPoke (const wxString &topic, const wxString &item, const void *data, size_t size, wxIPCFormat format)
| Message sent to the server application when the client notifies it to accept the given data. More...
virtual const void * | OnRequest (const wxString &topic, const wxString &item, size_t *size, wxIPCFormat format)
| Message sent to the server application when the client calls Request(). More...
virtual bool | OnStartAdvise (const wxString &topic, const wxString &item)
| Message sent to the server application by the client, when the client wishes to start an 'advise loop' for the given topic and item. More...
virtual bool | OnStopAdvise (const wxString &topic, const wxString &item)
| Message sent to the server application by the client, when the client wishes to stop an 'advise loop' for the given topic and item. More...
bool | Poke (const wxString &item, const void *data, size_t size, wxIPCFormat format=wxIPC_PRIVATE)
| Called by the client application to poke data into the server. More...
bool | Poke (const wxString &item, const char *data)
bool | Poke (const wxString &item, const wchar_t *data)
bool | Poke (const wxString &item, const wxString data)
virtual const void * | Request (const wxString &item, size_t *size=0, wxIPCFormat format=wxIPC_TEXT)
| Called by the client application to request data from the server. More...
virtual bool | StartAdvise (const wxString &item)
| Called by the client application to ask if an advise loop can be started with the server. More...
virtual bool | StopAdvise (const wxString &item)
| Called by the client application to ask if an advise loop can be stopped. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxTCPConnection() [1/2]

wxTCPConnection::wxTCPConnection | ( |  | ) |

Constructs a connection object.

If no user-defined connection object is to be derived from wxTCPConnection, then the constructor should not be called directly, since the default connection object will be provided on requesting (or accepting) a connection.

However, if the user defines his or her own derived connection object, the wxTCPServer::OnAcceptConnection and/or wxTCPClient::OnMakeConnection members should be replaced by functions which construct the new connection object.

If the arguments of the wxTCPConnection constructor are void, then a default buffer is associated with the connection. Otherwise, the programmer must provide a buffer and size of the buffer for the connection object to use in transactions.

## ◆ wxTCPConnection() [2/2]

wxTCPConnection::wxTCPConnection | ( | void * | buffer,
|  | size_t | size
| ) |  |

## Member Function Documentation

## ◆ Advise() [1/4]

bool wxTCPConnection::Advise | ( | const wxString & | item,
|  | const char * | data
| ) |  |

## ◆ Advise() [2/4]

bool wxTCPConnection::Advise | ( | const wxString & | item,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format = `wxIPC_PRIVATE`
| ) |  |

Called by the server application to advise the client of a change in the data associated with the given item.

Causes the client connection's OnAdvise() member to be called.

Returns true if successful.

## ◆ Advise() [3/4]

bool wxTCPConnection::Advise | ( | const wxString & | item,
|  | const wchar_t * | data
| ) |  |

## ◆ Advise() [4/4]

bool wxTCPConnection::Advise | ( | const wxString & | item,
|  | const wxString | data
| ) |  |

## ◆ Disconnect()

virtual bool wxTCPConnection::Disconnect | ( |  | ) |
| virtual

Called by the client or server application to disconnect from the other program; it causes the OnDisconnect() message to be sent to the corresponding connection object in the other program.

The default behaviour of OnDisconnect is to delete the connection, but the calling application must explicitly delete its side of the connection having called Disconnect.

Returns true if successful.

## ◆ Execute() [1/4]

bool wxTCPConnection::Execute | ( | const char * | data | ) |

## ◆ Execute() [2/4]

bool wxTCPConnection::Execute | ( | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format = `wxIPC_PRIVATE`
| ) |  |

Called by the client application to execute a command on the server.

Can also be used to transfer arbitrary data to the server (similar to Poke() in that respect). Causes the server connection's OnExecute() member to be called.

Returns true if successful.

## ◆ Execute() [3/4]

bool wxTCPConnection::Execute | ( | const wchar_t * | data | ) |

## ◆ Execute() [4/4]

bool wxTCPConnection::Execute | ( | const wxString | data | ) |

## ◆ OnAdvise()

virtual bool wxTCPConnection::OnAdvise | ( | const wxString & | topic,
|  | const wxString & | item,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format
| ) |  |
| virtual

Message sent to the client application when the server notifies it of a change in the data associated with the given item.

## ◆ OnDisconnect()

virtual bool wxTCPConnection::OnDisconnect | ( |  | ) |
| virtual

Message sent to the client or server application when the other application notifies it to delete the connection.

Default behaviour is to delete the connection object.

## ◆ OnExecute()

virtual bool wxTCPConnection::OnExecute | ( | const wxString & | topic,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format
| ) |  |
| virtual

Message sent to the server application when the client notifies it to execute the given data.

Note that there is no item associated with this message.

## ◆ OnPoke()

virtual bool wxTCPConnection::OnPoke | ( | const wxString & | topic,
|  | const wxString & | item,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format
| ) |  |
| virtual

Message sent to the server application when the client notifies it to accept the given data.

## ◆ OnRequest()

virtual const void * wxTCPConnection::OnRequest | ( | const wxString & | topic,
|  | const wxString & | item,
|  | size_t * | size,
|  | wxIPCFormat | format
| ) |  |
| virtual

Message sent to the server application when the client calls Request().

The server should respond by returning a character string from OnRequest, or NULL to indicate no data.

## ◆ OnStartAdvise()

virtual bool wxTCPConnection::OnStartAdvise | ( | const wxString & | topic,
|  | const wxString & | item
| ) |  |
| virtual

Message sent to the server application by the client, when the client wishes to start an 'advise loop' for the given topic and item.

The server can refuse to participate by returning false.

## ◆ OnStopAdvise()

virtual bool wxTCPConnection::OnStopAdvise | ( | const wxString & | topic,
|  | const wxString & | item
| ) |  |
| virtual

Message sent to the server application by the client, when the client wishes to stop an 'advise loop' for the given topic and item.

The server can refuse to stop the advise loop by returning false, although this doesn't have much meaning in practice.

## ◆ Poke() [1/4]

bool wxTCPConnection::Poke | ( | const wxString & | item,
|  | const char * | data
| ) |  |

## ◆ Poke() [2/4]

bool wxTCPConnection::Poke | ( | const wxString & | item,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format = `wxIPC_PRIVATE`
| ) |  |

Called by the client application to poke data into the server.

Can be used to transfer arbitrary data to the server. Causes the server connection's OnPoke() member to be called. Returns true if successful.

## ◆ Poke() [3/4]

bool wxTCPConnection::Poke | ( | const wxString & | item,
|  | const wchar_t * | data
| ) |  |

## ◆ Poke() [4/4]

bool wxTCPConnection::Poke | ( | const wxString & | item,
|  | const wxString | data
| ) |  |

## ◆ Request()

virtual const void * wxTCPConnection::Request | ( | const wxString & | item,
|  | size_t * | size = `0`,
|  | wxIPCFormat | format = `wxIPC_TEXT`
| ) |  |
| virtual

Called by the client application to request data from the server.

Causes the server connection's OnRequest() member to be called.

Returns a character string (actually a pointer to the connection's buffer) if successful, NULL otherwise.

## ◆ StartAdvise()

virtual bool wxTCPConnection::StartAdvise | ( | const wxString & | item | ) |
| virtual

Called by the client application to ask if an advise loop can be started with the server.

Causes the server connection's OnStartAdvise() member to be called. Returns true if the server okays it, false otherwise.

## ◆ StopAdvise()

virtual bool wxTCPConnection::StopAdvise | ( | const wxString & | item | ) |
| virtual

Called by the client application to ask if an advise loop can be stopped.

Causes the server connection's OnStopAdvise() member to be called. Returns true if the server okays it, false otherwise.